

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter c02
   Declare Ptrsafe Sub nag_zeros_complex_poly Lib "CLW6I26DE_nag.dll" Alias "c02afc" ( _
    ByVal n As long, _
    ByRef a As Complex, _
    ByVal dnscale As Nag_Boolean, _
    ByRef z As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_zeros_real_poly Lib "CLW6I26DE_nag.dll" Alias "c02agc" ( _
    ByVal n As long, _
    ByRef a As double, _
    ByVal dnscale As Nag_Boolean, _
    ByRef z As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_cubic_roots Lib "CLW6I26DE_nag.dll" Alias "c02akc" ( _
    ByVal u As double, _
    ByVal r As double, _
    ByVal s As double, _
    ByVal t As double, _
    ByRef zeror As double, _
    ByRef zeroi As double, _
    ByRef errest As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_quartic_roots Lib "CLW6I26DE_nag.dll" Alias "c02alc" ( _
    ByVal e As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal c As double, _
    ByVal d As double, _
    ByRef zeror As double, _
    ByRef zeroi As double, _
    ByRef errest As double, _
    ByRef fail As NagError _
   )


' chapter c05
' skeleton code for callback function
'  Function nag_zero_cont_func_brent_binsrch_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub nag_zero_cont_func_brent_binsrch Lib "CLW6I26DE_nag.dll" Alias "c05auc" ( _
    ByRef x As double, _
    ByVal h As double, _
    ByVal eps As double, _
    ByVal eta As double, _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_interval_zero_cont_func Lib "CLW6I26DE_nag.dll" Alias "c05avc" ( _
    ByRef x As double, _
    ByVal fx As double, _
    ByRef h As double, _
    ByVal boundl As double, _
    ByVal boundu As double, _
    ByRef y As double, _
    ByRef c As double, _
    ByRef ind As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_zero_cont_func_cntin_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub nag_zero_cont_func_cntin Lib "CLW6I26DE_nag.dll" Alias "c05awc" ( _
    ByRef x As double, _
    ByVal eps As double, _
    ByVal eta As double, _
    ByVal f As longPtr, _
    ByVal nfmax As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_zero_cont_func_cntin_rcomm Lib "CLW6I26DE_nag.dll" Alias "c05axc" ( _
    ByRef x As double, _
    ByVal fx As double, _
    ByVal tol As double, _
    ByVal ir As Nag_ErrorControl, _
    ByVal scal As double, _
    ByRef c As double, _
    ByRef ind As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_zero_cont_func_brent_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub nag_zero_cont_func_brent Lib "CLW6I26DE_nag.dll" Alias "c05ayc" ( _
    ByVal a As double, _
    ByVal b As double, _
    ByVal eps As double, _
    ByVal eta As double, _
    ByVal f As longPtr, _
    ByRef x As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_zero_cont_func_brent_rcomm Lib "CLW6I26DE_nag.dll" Alias "c05azc" ( _
    ByRef x As double, _
    ByRef y As double, _
    ByVal fx As double, _
    ByVal tolx As double, _
    ByVal ir As Nag_ErrorControl, _
    ByRef c As double, _
    ByRef ind As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Function nag_lambertW Lib "CLW6I26DE_nag.dll" Alias "c05bac" ( _
    ByVal x As double, _
    ByVal branch As long, _
    ByVal offset As Nag_Boolean, _
    ByRef fail As NagError _
   ) As double

   Declare Ptrsafe Sub nag_lambertW_complex Lib "CLW6I26DE_nag.dll" Alias "c05bbc" ( _
    ByVal branch As long, _
    ByVal offset As Nag_Boolean, _
    ByRef z As Complex, _
    ByRef w As Complex, _
    ByRef resid As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_zero_nonlin_eqns_easy_fcn( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef iflag As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_zero_nonlin_eqns_easy Lib "CLW6I26DE_nag.dll" Alias "c05qbc" ( _
    ByVal fcn As longPtr, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByVal xtol As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_zero_nonlin_eqns_expert_fcn( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef iflag As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_zero_nonlin_eqns_expert Lib "CLW6I26DE_nag.dll" Alias "c05qcc" ( _
    ByVal fcn As longPtr, _
    ByVal n As long, ByRef x As double, _
    ByRef fvec As double, ByVal xtol As double, ByVal maxfev As long, _
    ByVal ml As long, ByVal mu As long, ByVal epsfcn As double, _
    ByVal scale_mode As Nag_ScaleType, ByRef diag As double, ByVal factor As double, _
    ByVal nprint As long, ByRef nfev As long, ByRef fjac As double, _
    ByRef r As double, ByRef qtf As double, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_zero_nonlin_eqns_rcomm Lib "CLW6I26DE_nag.dll" Alias "c05qdc" ( _
    ByRef irevcm As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByVal xtol As double, _
    ByVal ml As long, _
    ByVal mu As long, _
    ByVal epsfcn As double, _
    ByVal scale_mode As Nag_ScaleType, _
    ByRef diag As double, _
    ByVal factor As double, _
    ByRef fjac As double, _
    ByRef r As double, _
    ByRef qtf As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_zero_sparse_nonlin_eqns_easy_fcn( _
'      ByVal n As long, _
'      ByVal lindf As long, _
'      ByVal indf_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef iflag As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_zero_sparse_nonlin_eqns_easy Lib "CLW6I26DE_nag.dll" Alias "c05qsc" ( _
    ByVal fcn As longPtr, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByVal xtol As double, _
    ByVal init As Nag_Boolean, _
    ByRef rcomm As double, _
    ByVal lrcomm As long, _
    ByRef icomm As long, _
    ByVal licomm As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_zero_nonlin_eqns_deriv_easy_fcn( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef iflag As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_zero_nonlin_eqns_deriv_easy Lib "CLW6I26DE_nag.dll" Alias "c05rbc" ( _
    ByVal fcn As longPtr, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal xtol As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_zero_nonlin_eqns_deriv_expert_fcn( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef iflag As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_zero_nonlin_eqns_deriv_expert Lib "CLW6I26DE_nag.dll" Alias "c05rcc" ( _
    ByVal fcn As longPtr, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal xtol As double, _
    ByVal maxfev As long, _
    ByVal scale_mode As Nag_ScaleType, _
    ByRef diag As double, _
    ByVal factor As double, _
    ByVal nprint As long, _
    ByRef nfev As long, _
    ByRef njev As long, _
    ByRef r As double, _
    ByRef qtf As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_zero_nonlin_eqns_deriv_rcomm Lib "CLW6I26DE_nag.dll" Alias "c05rdc" ( _
    ByRef irevcm As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal xtol As double, _
    ByVal scale_mode As Nag_ScaleType, _
    ByRef diag As double, _
    ByVal factor As double, _
    ByRef r As double, _
    ByRef qtf As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_check_derivs Lib "CLW6I26DE_nag.dll" Alias "c05zdc" ( _
    ByVal mode As long, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByRef xp As double, _
    ByRef fvecp As double, _
    ByRef err As double, _
    ByRef fail As NagError _
   )


' chapter c06
   Declare Ptrsafe Sub nag_sum_cheby_series Lib "CLW6I26DE_nag.dll" Alias "c06dcc" ( _
    ByRef x As double, _
    ByVal lx As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef c As double, _
    ByVal n As long, _
    ByVal s As Nag_Series, _
    ByRef res As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_convcorr_real Lib "CLW6I26DE_nag.dll" Alias "c06fkc" ( _
    ByVal job As Nag_VectorOp, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal n As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fft_multiple_real Lib "CLW6I26DE_nag.dll" Alias "c06fpc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef trig As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fft_multiple_hermitian Lib "CLW6I26DE_nag.dll" Alias "c06fqc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef trig As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_multiple_conjugate_hermitian Lib "CLW6I26DE_nag.dll" Alias "c06gqc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_multiple_hermitian_to_complex Lib "CLW6I26DE_nag.dll" Alias "c06gsc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fft_init_trig Lib "CLW6I26DE_nag.dll" Alias "c06gzc" ( _
    ByVal n As long, _
    ByRef trig As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_realherm_1d Lib "CLW6I26DE_nag.dll" Alias "c06pac" ( _
    ByVal direct As Nag_TransformDirection, _
    ByRef x As double, _
    ByVal n As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_complex_1d Lib "CLW6I26DE_nag.dll" Alias "c06pcc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByRef x As Complex, _
    ByVal n As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fft_multid_single Lib "CLW6I26DE_nag.dll" Alias "c06pfc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal ndim As long, _
    ByVal l As long, _
    ByRef nd As long, _
    ByVal n As long, _
    ByRef x As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fft_multid_full Lib "CLW6I26DE_nag.dll" Alias "c06pjc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal ndim As long, _
    ByRef nd As long, _
    ByVal n As long, _
    ByRef x As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_complex_1d_multi Lib "CLW6I26DE_nag.dll" Alias "c06psc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef x As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_complex_2d Lib "CLW6I26DE_nag.dll" Alias "c06puc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_real_2d Lib "CLW6I26DE_nag.dll" Alias "c06pvc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_hermitian_2d Lib "CLW6I26DE_nag.dll" Alias "c06pwc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef y As Complex, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fft_3d Lib "CLW6I26DE_nag.dll" Alias "c06pxc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal n1 As long, _
    ByVal n2 As long, _
    ByVal n3 As long, _
    ByRef x As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_real_3d Lib "CLW6I26DE_nag.dll" Alias "c06pyc" ( _
    ByVal n1 As long, _
    ByVal n2 As long, _
    ByVal n3 As long, _
    ByRef x As double, _
    ByRef y As Complex, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_hermitian_3d Lib "CLW6I26DE_nag.dll" Alias "c06pzc" ( _
    ByVal n1 As long, _
    ByVal n2 As long, _
    ByVal n3 As long, _
    ByRef y As Complex, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_sine Lib "CLW6I26DE_nag.dll" Alias "c06rec" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_cosine Lib "CLW6I26DE_nag.dll" Alias "c06rfc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_qtrsine Lib "CLW6I26DE_nag.dll" Alias "c06rgc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_sum_fft_qtrcosine Lib "CLW6I26DE_nag.dll" Alias "c06rhc" ( _
    ByVal direct As Nag_TransformDirection, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


' chapter c09
   Declare Ptrsafe Sub nag_wfilt Lib "CLW6I26DE_nag.dll" Alias "c09aac" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal n As long, _
    ByRef nwlmax As long, _
    ByRef nf As long, _
    ByRef nwc As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_wfilt_2d Lib "CLW6I26DE_nag.dll" Alias "c09abc" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef nwlmax As long, _
    ByRef nf As long, _
    ByRef nwct As long, _
    ByRef nwcn As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_wfilt_3d Lib "CLW6I26DE_nag.dll" Alias "c09acc" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wtrans As Nag_WaveletTransform, _
    ByVal mode As Nag_WaveletMode, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal fr As long, _
    ByRef nwlmax As long, _
    ByRef nf As long, _
    ByRef nwct As long, _
    ByRef nwcn As long, _
    ByRef nwcfr As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_cwt_1d_real Lib "CLW6I26DE_nag.dll" Alias "c09bac" ( _
    ByVal wavnam As Nag_Wavelet, _
    ByVal wparam As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal nscal As long, _
    ByRef scales As long, _
    ByRef c As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_dwt Lib "CLW6I26DE_nag.dll" Alias "c09cac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal lenc As long, _
    ByRef ca As double, _
    ByRef cd As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_idwt Lib "CLW6I26DE_nag.dll" Alias "c09cbc" ( _
    ByVal lenc As long, _
    ByRef ca As double, _
    ByRef cd As double, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_mldwt Lib "CLW6I26DE_nag.dll" Alias "c09ccc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal nwl As long, _
    ByRef dwtlev As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_imldwt Lib "CLW6I26DE_nag.dll" Alias "c09cdc" ( _
    ByVal nwlinv As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_modwt Lib "CLW6I26DE_nag.dll" Alias "c09dac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal lenc As long, _
    ByRef ca As double, _
    ByRef cd As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_imodwt Lib "CLW6I26DE_nag.dll" Alias "c09dbc" ( _
    ByVal lenc As long, _
    ByRef ca As double, _
    ByRef cd As double, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_mlmodwt Lib "CLW6I26DE_nag.dll" Alias "c09dcc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal keepa As Nag_WaveletCoefficients, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal nwl As long, _
    ByRef na As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_imlmodwt Lib "CLW6I26DE_nag.dll" Alias "c09ddc" ( _
    ByVal nwlinv As long, _
    ByVal keepa As Nag_WaveletCoefficients, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal n As long, _
    ByRef y As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_dwt_2d Lib "CLW6I26DE_nag.dll" Alias "c09eac" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal lda As long, _
    ByRef ca As double, _
    ByVal ldca As long, _
    ByRef ch As double, _
    ByVal ldch As long, _
    ByRef cv As double, _
    ByVal ldcv As long, _
    ByRef cd As double, _
    ByVal ldcd As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_idwt_2d Lib "CLW6I26DE_nag.dll" Alias "c09ebc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef ca As double, _
    ByVal ldca As long, _
    ByRef ch As double, _
    ByVal ldch As long, _
    ByRef cv As double, _
    ByVal ldcv As long, _
    ByRef cd As double, _
    ByVal ldcd As long, _
    ByRef b As double, _
    ByVal ldb As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_mldwt_2d Lib "CLW6I26DE_nag.dll" Alias "c09ecc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal lda As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal nwl As long, _
    ByRef dwtlvm As long, _
    ByRef dwtlvn As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_imldwt_2d Lib "CLW6I26DE_nag.dll" Alias "c09edc" ( _
    ByVal nwlinv As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef b As double, _
    ByVal ldb As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_wav_2d_coeff_ext Lib "CLW6I26DE_nag.dll" Alias "c09eyc" ( _
    ByVal ilev As long, _
    ByVal cindex As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByRef d As double, _
    ByVal pdd As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_wav_2d_coeff_ins Lib "CLW6I26DE_nag.dll" Alias "c09ezc" ( _
    ByVal ilev As long, _
    ByVal cindex As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByRef d As double, _
    ByVal pdd As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_dwt_3d Lib "CLW6I26DE_nag.dll" Alias "c09fac" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal fr As long, _
    ByRef a As double, _
    ByVal lda As long, _
    ByVal sda As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_idwt_3d Lib "CLW6I26DE_nag.dll" Alias "c09fbc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal fr As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByRef b As double, _
    ByVal ldb As long, _
    ByVal sdb As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_mldwt_3d Lib "CLW6I26DE_nag.dll" Alias "c09fcc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal fr As long, _
    ByRef a As double, _
    ByVal lda As long, _
    ByVal sda As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal nwl As long, _
    ByRef dwtlvm As long, _
    ByRef dwtlvn As long, _
    ByRef dwtlvfr As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_imldwt_3d Lib "CLW6I26DE_nag.dll" Alias "c09fdc" ( _
    ByVal nwlinv As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal fr As long, _
    ByRef b As double, _
    ByVal ldb As long, _
    ByVal sdb As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_wav_3d_coeff_ext Lib "CLW6I26DE_nag.dll" Alias "c09fyc" ( _
    ByVal ilev As long, _
    ByVal cindex As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByRef d As double, _
    ByVal ldd As long, _
    ByVal sdd As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_wav_3d_coeff_ins Lib "CLW6I26DE_nag.dll" Alias "c09fzc" ( _
    ByVal ilev As long, _
    ByVal cindex As long, _
    ByVal lenc As long, _
    ByRef c As double, _
    ByRef d As double, _
    ByVal ldd As long, _
    ByVal sdd As long, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )

